package com.codvision.auth.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.codvision.auth.entity.Org;
import com.codvision.auth.entity.OrgProperty;
import com.codvision.auth.entity.dto.SysOrgQueryDTO;
import com.codvision.auth.entity.excel.OrgExcel;
import com.codvision.auth.entity.vo.OrgVO;
import com.codvision.webcore.bean.QueryPage;
import com.codvision.webcore.service.IBaseService;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * <p>
 * 组织信息 服务类
 * </p>
 *
 * @author lingee
 * @since 2023-11-10
 */
public interface IOrgService extends IBaseService<Org, OrgVO> {

    /**
     * 获取组织信息详情
     *
     * @param oid
     * @return 组织信息
     */
    OrgVO getDetail(Integer oid);

    /**
     * 获取默认组织（默认第一个组织）
     *
     * @return 组织信息
     */
    Org getDefaultOrg();

    /**
     * 获取组织信息分页列表
     *
     * @param queryPage 分页条件
     * @param queryDTO  查询条件
     * @return 分页结果
     */
    IPage<OrgVO> findAll(QueryPage<Org> queryPage, SysOrgQueryDTO queryDTO);

    /**
     * 添加组织
     *
     * @param org 组织信息
     * @return
     */
    OrgVO addOrg(Org org);

    /**
     * 更新组织
     *
     * @param org 组织信息
     * @return
     */
    OrgVO updateOrg(Org org);

    /**
     * 逻辑删除组织
     *
     * @param oid 组织id
     */
    void logicDel(Integer oid);

    /**
     * 获取组织树
     *
     * @param root 根id
     * @return 组织
     */
    OrgVO getTree(Integer root);

    /**
     * 导入组织数据
     *
     * @param file 文件
     * @return 导入结果
     */
    String excelImport(MultipartFile file);

    /**
     * excel保存
     *
     * @param cachedDataList  缓存数据列表
     * @param orgList         组织列表
     * @param orgPropertyList 组织属性列表
     */
    void excelSave(List<OrgExcel> cachedDataList, List<OrgVO> orgList, List<OrgProperty> orgPropertyList);

    void excelExport(SysOrgQueryDTO queryBean);

    /**
     * 查询所有组织列表
     *
     * @param queryDTO 查询条件
     * @return 组织列表
     */
    List<OrgVO> findAll(SysOrgQueryDTO queryDTO);
}
